/*
 * Copyright 2003-2010 Netlogic Microsystems (“Netlogic”). All rights
 * reserved. Redistribution and use in source and binary forms, with 
 * or without modification, are permitted provided that the following 
 * conditions are met:
 *
 *	1. 	Redistributions of source code must retain the above copyright
 *		notice, this list of conditions and the following disclaimer.
 *
 *	2. 	Redistributions in binary form must reproduce the above copyright
 *		notice, this list of conditions and the following disclaimer in
 *		the documentation and/or other materials provided with the
 *		distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY Netlogic Microsystems ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL NETLOGIC OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
 * THE POSSIBILITY OF SUCH DAMAGE.
 * --------------------------------#NETL_2#--------------------------------
 */
#ifndef __XLP_BRIDGE_H__
#define __XLP_BRIDGE_H__

#define NUM_DRAM_BARS 					8

#define NBU_GCU_EN                                      (1<<1)
#define NBU_DMC_RDCRD_DISABLE                           (1<<6)
/* XLP Bridge(NBU) Register Block : Cfg and E-Cfg */

#define NBU_MODE_REG					0
#define NBU_CFG_BAR_ADDR				1
#define NBU_CFG_BAR_LIMIT				2
#define NBU_ECFG_BAR_ADDR				3
#define NBU_ECFG_BAR_LIMIT				4

/* XLP Bridge(NBU) Register Block : PCI-E Link Bus #s */

#define NBU_BUSNUM_BAR_0				5
#define NBU_BUSNUM_BAR_1				6
#define NBU_BUSNUM_BAR_2				7
#define NBU_BUSNUM_BAR_3				8
#define NBU_BUSNUM_BAR_4				9
#define NBU_BUSNUM_BAR_5				10
#define NBU_BUSNUM_BAR_6				11

/* XLP Bridge(NBU) Register Block : FLASH */

#define NBU_FLASH_BAR_0					12
#define NBU_FLASH_BAR_1					13
#define NBU_FLASH_BAR_2					14
#define NBU_FLASH_BAR_3					15
#define NBU_FLASH_BAR_LIMIT_0			16
#define NBU_FLASH_BAR_LIMIT_1			17
#define NBU_FLASH_BAR_LIMIT_2			18	
#define NBU_FLASH_BAR_LIMIT_3			19

/* XLP Bridge(NBU) Register Block : DRAM */

#define NBU_DRAM_BAR_0                  20 			
#define NBU_DRAM_BAR_1                  21 
#define NBU_DRAM_BAR_2                  22
#define NBU_DRAM_BAR_3                  23
#define NBU_DRAM_BAR_4                  24
#define NBU_DRAM_BAR_5                  25
#define NBU_DRAM_BAR_6                  26
#define NBU_DRAM_BAR_7                  27
#define NBU_DRAM_BAR_LIMIT_0            28
#define NBU_DRAM_BAR_LIMIT_1            29
#define NBU_DRAM_BAR_LIMIT_2            30
#define NBU_DRAM_BAR_LIMIT_3            31
#define NBU_DRAM_BAR_LIMIT_4            32
#define NBU_DRAM_BAR_LIMIT_5            33
#define NBU_DRAM_BAR_LIMIT_6            34
#define NBU_DRAM_BAR_LIMIT_7            35
#define NBU_DRAM_BAR_NODEADDR_XLAT_0 	36
#define NBU_DRAM_BAR_NODEADDR_XLAT_1 	37
#define NBU_DRAM_BAR_NODEADDR_XLAT_2 	38
#define NBU_DRAM_BAR_NODEADDR_XLAT_3 	39
#define NBU_DRAM_BAR_NODEADDR_XLAT_4 	40
#define NBU_DRAM_BAR_NODEADDR_XLAT_5 	41
#define NBU_DRAM_BAR_NODEADDR_XLAT_6 	42
#define NBU_DRAM_BAR_NODEADDR_XLAT_7 	43
#define NBU_DRAM_BAR_XLAT_0         	44
#define NBU_DRAM_BAR_XLAT_1         	45
#define NBU_DRAM_BAR_XLAT_2         	46
#define NBU_DRAM_BAR_XLAT_3         	47
#define NBU_DRAM_BAR_XLAT_4         	48
#define NBU_DRAM_BAR_XLAT_5         	49
#define NBU_DRAM_BAR_XLAT_6         	50
#define NBU_DRAM_BAR_XLAT_7         	51

/* XLP Bridge(NBU) Register Block : PCIE */

#define NBU_PCIE_MEM_BAR_0				52
#define NBU_PCIE_MEM_BAR_1				53
#define NBU_PCIE_MEM_BAR_2				54
#define NBU_PCIE_MEM_BAR_3				55

#define NBU_PCIE_MEM_BAR_LIMIT_0 		56
#define NBU_PCIE_MEM_BAR_LIMIT_1 		57
#define NBU_PCIE_MEM_BAR_LIMIT_2 		58
#define NBU_PCIE_MEM_BAR_LIMIT_3 		59

#define NBU_PCIE_IO_BAR_0				60
#define NBU_PCIE_IO_BAR_1 				61
#define NBU_PCIE_IO_BAR_2				62
#define NBU_PCIE_IO_BAR_3				63

#define NBU_PCIE_IO_BAR_LIMIT_0 		64
#define NBU_PCIE_IO_BAR_LIMIT_1 		65
#define NBU_PCIE_IO_BAR_LIMIT_2 		66
#define NBU_PCIE_IO_BAR_LIMIT_3 		67

#define NBU_PCIE_MEM_BAR_4  			68
#define NBU_PCIE_MEM_BAR_5 				69
#define NBU_PCIE_MEM_BAR_6 				70

#define NBU_PCIE_MEM_BAR_LIMIT_4 		71   
#define NBU_PCIE_MEM_BAR_LIMIT_5 		72
#define NBU_PCIE_MEM_BAR_LIMIT_6 		73

#define NBU_PCIE_IO_BAR_4 				74  
#define NBU_PCIE_IO_BAR_5 				75
#define NBU_PCIE_IO_BAR_6 				76

#define NBU_PCIE_IO_BAR_LIMIT_4 		77  
#define NBU_PCIE_IO_BAR_LIMIT_5 		78
#define NBU_PCIE_IO_BAR_LIMIT_6 		79

/* XLP Bridge(NBU) Register Block : Debug/Error Registers */

#define NBU_EVENT_CNT_CLT1         		80  
#define NBU_EVENT_CNT_1_LOW				81
#define NBU_EVENT_CNT_1_HIGH 			82
#define NBU_EVENT_CNT_CLT2 				83
#define NBU_EVENT_CNT_2_LOW 			84
#define NBU_EVENT_CNT_2_HIGH 			85

#define NBU_TBUF_MATCHING_REG0 			86
#define NBU_TBUF_MATCHING_REG1 			87
#define NBU_TBUF_MATCHING_REG2 			88
#define NBU_TBUF_MATCHING_REG3 			89
#define NBU_TBUF_CONTROL_REG        	90	  
#define NBU_TBUF_INIT_REG				91
#define NBU_TBUF_ACCESS_REG				92
#define NBU_TBUF_READ_DATA_REG0     	93
#define NBU_TBUF_READ_DATA_REG1     	94
#define NBU_TBUF_READ_DATA_REG2     	95
#define NBU_TBUF_READ_DATA_REG3     	96
#define NBU_TBUF_STATUS_REG				97
	
#define NBU_BAR_ADDRESS_ERROR_REG0 		98
#define NBU_BAR_ADDRESS_ERROR_REG1		99
#define NBU_BAR_ADDRESS_ERROR_REG2		100

#define NBU_TAG_ECC_ADDRESS_ERROR_REG0	101
#define NBU_TAG_ECC_ADDRESS_ERROR_REG1	102
#define NBU_TAG_ECC_ADDRESS_ERROR_REG2	103

#define NBU_LINE_FLUSH_REG0				104
#define NBU_LINE_FLUSH_REG1				105
		
#define NBU_NODE_ID_REG					106

/*
 */
#define NBU_DDR_CHAN_INTMODE_0          0x0
#define NBU_DDR_CHAN_INTMODE_1          0x1
#define NBU_DDR_CHAN_INTMODE_2          0x2
#define NBU_DDR_CHAN_INTMODE_3          0x3
#define NBU_DDR_CHAN_INTMODE_0_2        0x4
#define NBU_DDR_CHAN_INTMODE_0_1        0x5
#define NBU_DDR_CHAN_INTMODE_2_3        0x6
#define NBU_DDR_CHAN_INTMODE_0_1_2_3    0x7

#define NBU_DDR_CHAN_INTBITS_7_6        0x0
#define NBU_DDR_CHAN_INTBITS_8_7        0x1
#define NBU_DDR_CHAN_INTBITS_9_8        0x2
#define NBU_DDR_CHAN_INTBITS_10_9       0x3
#define NBU_DDR_CHAN_INTBITS_11_10      0x4

#define NBU_DDR_CHAN_INTBITS_6          0x0
#define NBU_DDR_CHAN_INTBITS_7          0x1
#define NBU_DDR_CHAN_INTBITS_8          0x2
#define NBU_DDR_CHAN_INTBITS_9          0x3
#define NBU_DDR_CHAN_INTBITS_10         0x4

#define NBU_DDR_NODE_INTMODE_0          0x0
#define NBU_DDR_NODE_INTMODE_1          0x1
#define NBU_DDR_NODE_INTMODE_2          0x2
#define NBU_DDR_NODE_INTMODE_3          0x3
#define NBU_DDR_NODE_INTMODE_0_2        0x4
#define NBU_DDR_NODE_INTMODE_0_1        0x5
#define NBU_DDR_NODE_INTMODE_2_3        0x6
#define NBU_DDR_NODE_INTMODE_0_1_2_3    0x7

#define NBU_DDR_NODE_INTBITS_13_12      0x0
#define NBU_DDR_NODE_INTBITS_14_13      0x1
#define NBU_DDR_NODE_INTBITS_15_14      0x2
#define NBU_DDR_NODE_INTBITS_16_15      0x3
#define NBU_DDR_NODE_INTBITS_17_16      0x4

#define NBU_DDR_NODE_INTBITS_12         0x0
#define NBU_DDR_NODE_INTBITS_13         0x1
#define NBU_DDR_NODE_INTBITS_14         0x2
#define NBU_DDR_NODE_INTBITS_15         0x3
#define NBU_DDR_NODE_INTBITS_16         0x4

#endif /* __XLP_BRIDGE_H__ */
