/*
 * Copyright 2003-2010 Netlogic Microsystems (“Netlogic”). All rights
 * reserved. Redistribution and use in source and binary forms, with 
 * or without modification, are permitted provided that the following 
 * conditions are met:
 *
 *	1. 	Redistributions of source code must retain the above copyright
 *		notice, this list of conditions and the following disclaimer.
 *
 *	2. 	Redistributions in binary form must reproduce the above copyright
 *		notice, this list of conditions and the following disclaimer in
 *		the documentation and/or other materials provided with the
 *		distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY Netlogic Microsystems ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL NETLOGIC OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
 * THE POSSIBILITY OF SUCH DAMAGE.
 * --------------------------------#NETL_2#--------------------------------
 */
#ifndef __XLP_I2C_H_
#define __XLP_I2C_H_

#define I2C_CLKFREQ_KHZ			(1/7.5e-9)
#define I2C_TIMEOUT				500000

/* These defines pertain to the OpenCores
 * I2C Master Host Controller used in XLP
 */

#define OC_PRESCALER_LO			0
#define OC_PRESCALER_HI			1
#define OC_CONTROL				2
	#define OC_CONTROL_EN		0x80
	#define OC_CONTROL_IEN		0x40
#define OC_DATA					3		/* Data TX & RX Reg */
#define OC_COMMAND				4
	#define OC_COMMAND_START	0x90
	#define OC_COMMAND_STOP		0x40
	#define OC_COMMAND_READ		0x20
	#define OC_COMMAND_WRITE	0x10
	#define OC_COMMAND_RDACK	0x20
	#define OC_COMMAND_RDNACK	0x28
	#define OC_COMMAND_IACK		0x01	/* Not used */
#define OC_STATUS				4		/* Same as 'command' */
	#define OC_STATUS_NACK		0x80	/* Did not get an ACK */ 				
	#define OC_STATUS_BUSY		0x40				
	#define OC_STATUS_AL		0x20	/* Arbitration Lost */				
	#define OC_STATUS_TIP		0x02	/* Transfer in Progress  */				
	#define OC_STATUS_IF		0x01	/* Intr. Pending Flag, not used */

#define WRITE_BIT				0x00
#define READ_BIT				0x01

#endif /* __XLP_I2C_H_ */
