/*
 * Copyright 2003-2010 Netlogic Microsystems (“Netlogic”). All rights
 * reserved. Redistribution and use in source and binary forms, with 
 * or without modification, are permitted provided that the following 
 * conditions are met:
 *
 *	1. 	Redistributions of source code must retain the above copyright
 *		notice, this list of conditions and the following disclaimer.
 *
 *	2. 	Redistributions in binary form must reproduce the above copyright
 *		notice, this list of conditions and the following disclaimer in
 *		the documentation and/or other materials provided with the
 *		distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY Netlogic Microsystems ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL NETLOGIC OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
 * THE POSSIBILITY OF SUCH DAMAGE.
 * --------------------------------#NETL_2#--------------------------------
 */
#ifndef __XLP_ICI_H__
#define __XLP_ICI_H__

#ifndef __ASSEMBLY__

#define ICI_NUM_LINKS 3
#define ICI_RX_LANE_SYNC(x) ((x&0xff)==0xff)
#define ICI_RX_LANE_ALIGN(x) ((x&(1<<18))!=0)
#define ICI_CREDLD_SNDPRB  (1<<1)
#define ICI_CREDLD_PRBACK  (1<<2)
#define ICI_CREDLD_SNDNODE (1<<7)
#define ICI_CREDLD_NODERCV (1<<9)
#define ICI_CREDLD_PEERID(x) (x<<4)
#define ICI_LINKUP         (1<<6)
#define ICI_SFEN           (1<<10)
#define ICI_CDRRSTEN       (1<<11) 
#define ICI_CDRLARXRSTEN   (1<<12)

enum processor_ici
{
	ICI_CTL = 0,
	ICI_RTRY_TIMER = 1,
	ICI_ICIINT = 2,
	ICI_ICIINTMASK = 3,
	ICI_CRED_RT_TH0 = 4,
	ICI_CRED_RT_TH1 = 5,
	ICI_CRED_RT_TH2 = 6,
	ICI_CRED_RT_TH3 = 7,
	ICI_TXWGHT0 = 8,
	ICI_TXWGHT1 = 9,
	ICI_TXWGHT2 = 10,
	ICI_TXWGHT3 = 11,
	ICI_TXWGHT4 = 12,
	ICI_TXWGHT5 = 13,
	ICI_TXWGHT6 = 14,
	ICI_TXWGHT7 = 15,
	ICI_TXWGHT8 = 16,
	ICI_TXWGHT9 = 17,
	ICI_TXWGHT10 = 18,
	ICI_TXWGHT11 = 19,
	ICI_TXWGHT12 = 20,
	ICI_TXWGHT13 = 21,
	ICI_TXWGHT14 = 22,
	ICI_TXSEGTH0 = 23,
	ICI_TXSEGTH1 = 24,
	ICI_TXSEGTH2 = 25,
	ICI_TXSEGTH3 = 26,
	ICI_TXSEGTH4 = 27,
	ICI_TXSEGTH5 = 28,
	ICI_TXSEGTH6 = 29,
	ICI_TXSEGTH7 = 30,
	ICI_TXSEGTH8 = 31,
	ICI_TXSEGTH9 = 32,
	ICI_TXSEGTH10 = 33,
	ICI_TXSEGTH11 = 34,
	ICI_TXSEGTH12 = 35,
	ICI_TXSEGTH13 = 36,
	ICI_TXSEGTH14 = 37,
	ICI_CREDSHARE0 = 38,
	ICI_CREDSHARE1 = 39,
	ICI_CREDSHARE2 = 40,
	ICI_CREDSHARE3 = 41,
	ICI_CREDSHARE4 = 42,
	ICI_CREDSHARE5 = 43,
	ICI_CREDSHARE6 = 44,
	ICI_CREDSHARE7 = 45,
	ICI_CREDSHARE8 = 46,
	ICI_CREDSHARE9 = 47,
	ICI_CREDSHARE10 = 48,
	ICI_CREDSHARE11 = 49,
	ICI_CREDSHARE12 = 50,
	ICI_CREDSHARE13 = 51,
	ICI_CREDSHARE14 = 52,
	ICI_CREDOWN0 = 53,
	ICI_CREDOWN1 = 54,
	ICI_CREDOWN2 = 55,
	ICI_CREDOWN3 = 56,
	ICI_CREDOWN4 = 57,
	ICI_CREDOWN5 = 58,
	ICI_CREDOWN6 = 59,
	ICI_CREDOWN7 = 60,
	ICI_CREDOWN8 = 61,
	ICI_CREDOWN9 = 62,
	ICI_CREDOWN10 = 63,
	ICI_CREDOWN11 = 64,
	ICI_CREDOWN12 = 65,
	ICI_CREDOWN13 = 66,
	ICI_CREDOWN14 = 67,
	ICI_CREDTOT = 68,
	ICI_CREDLD = 69,
	ICI_SPEPKTCNT = 70,
	ICI_CRED_TOTRd = 71,
	ICI_CREDPERVC0 = 72,
	ICI_CREDPERVC1 = 73,
	ICI_CREDPERVC2 = 74,
	ICI_CREDPERVC3 = 75,
	ICI_CREDPERVC4 = 76,
	ICI_CREDPERVC5 = 77,
	ICI_CREDPERVC6 = 78,
	ICI_CREDPERVC7 = 79,
	ICI_CREDPERVC8 = 80,
	ICI_CREDPERVC9 = 81,
	ICI_CREDPERVC10 = 82,
	ICI_CREDPERVC11 = 83,
	ICI_CREDPERVC12 = 84,
	ICI_CREDPERVC13 = 85,
	ICI_CREDPERVC14 = 86,
	ICI_TXFREELIST = 87,
	ICI_RXFREELIST0 = 88,
	ICI_RXFREELIST1 = 89,
	ICI_RXFREELIST2 = 90,
	ICI_RXFREELIST3 = 91,
	ICI_ECC_LOG = 92,
	ICI_ECC_TRIG = 93,
	ICI_CNT_CTL = 94,
	ICI_PKT_CNT_CTL = 95,
	ICI_PKT_TX_CNT = 96,
	ICI_PKT_RX_CNT = 97,
	ICI_TEST_CTL = 98,
	ICI_TX_TEST_HEAD = 99,
	ICI_TX_TEST_DATA0_L = 100,
	ICI_TX_TEST_DATA0_H = 101,
	ICI_RX_TEST_HEAD = 102,
	ICI_RX_TEST_DATA0_L = 103,
	ICI_RX_TEST_DATA0_H = 104,
	ICI_LA_INT_REG = 105,
	ICI_LA_INTMASK = 106,
	ICI_LA_RX_DIAG = 107,
	ICI_LA_RX_SYNC = 108,
	ICI_LA_ERROR_REG1 = 109,
	ICI_LA_ERROR_REG2 = 110,
	ICI_LA_TX_ENABLE = 111,
	ICI_LA_BAD_LANE = 112,
	ICI_LA_TX_STAT = 113,
	ICI_LA_TX_RLIM = 114,
	ICI_LA_SETUP = 115,
	ICI_LA_LEN = 116,
	ICI_SER_CTL = 117,
	ICI_SER_REG0 = 118,
	ICI_SER_REG_ALL = 119,
	ICI_IO_CONFIG_SWAP_DIS = 120
};
#endif

#endif /* __XLP_ICI_H__ */
