/*
 * Copyright 2003-2010 Netlogic Microsystems (“Netlogic”). All rights
 * reserved. Redistribution and use in source and binary forms, with 
 * or without modification, are permitted provided that the following 
 * conditions are met:
 *
 *	1. 	Redistributions of source code must retain the above copyright
 *		notice, this list of conditions and the following disclaimer.
 *
 *	2. 	Redistributions in binary form must reproduce the above copyright
 *		notice, this list of conditions and the following disclaimer in
 *		the documentation and/or other materials provided with the
 *		distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY Netlogic Microsystems ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL NETLOGIC OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
 * THE POSSIBILITY OF SUCH DAMAGE.
 * --------------------------------#NETL_2#--------------------------------
 */
#ifndef __XLP_SYS_H__
#define __XLP_SYS_H__

#define SYS_CHIPRESET_REG  0
#define SYS_POWERONRESETCFG_REG  1
#define SYS_EFUSEDEVICECFG0_REG  2
#define SYS_EFUSEDEVICECFG1_REG  3
#define SYS_EFUSEDEVICECFG2_REG  4
#define SYS_EFUSEDEVICECFG3_REG  5
#define SYS_EFUSEDEVICECFG4_REG  6
#define SYS_EFUSEDEVICECFG5_REG  7
#define SYS_EFUSEDEVICECFG6_REG  8
#define SYS_EFUSEDEVICECFG7_REG  9
#define SYS_PLLCTRL_REG  10
#define SYS_CPURESET_REG  11
#define SYS_CPUTHREADEN_REG  12
#define SYS_CPUNONCOHERENTMODE_REG  13
#define SYS_COREDFSDISCTRL_REG  14
#define SYS_COREDFSRSTCTRL_REG  15
#define SYS_COREDFSBYPCTRL_REG  16
#define SYS_COREDFSPHACTRL_REG  17
#define SYS_COREDFSDIVINCCTRL_REG  18
#define SYS_COREDFSDIVDECCTRL_REG  19
#define SYS_COREDFSDIVCTRL_REG  20
#define SYS_SYSRESET_REG  21
#define SYS_SYSDFSDISCTRL_REG  22
#define SYS_SYSDFSRSTCTRL_REG  23
#define SYS_SYSDFSBYPCTRL_REG  24
#define SYS_SYSDFSDIVINCCTRL_REG  25
#define SYS_SYSDFSDIVDECCTRL_REG  26
#define SYS_SYSDFSDIVCTRL0_REG  27
#define SYS_SYSDFSDIVCTRL1_REG  28
#define SYS_CPUSENSEAMPDLY_REG  29
#define SYS_SOCSENSEAMPDLY_REG  30
#define SYS_SYSCTRL0_REG  31
#define SYS_SYSCTRL1_REG  32
#define SYS_TIMEOUTBSI_REG  33
#define SYS_BYTESWAP_REG  34
#define SYS_SYSVRMVID_REG  35
#define SYS_SYSPWRRAMCMD_REG  36
#define SYS_SYSPWRRAMADDR_REG  37
#define SYS_SYSPWRRAMDATA0_REG  38
#define SYS_SYSPWRRAMDATA1_REG  39
#define SYS_SYSPWRRAMDATA2_REG  40
#define SYS_SYSPWRUCODE_REG  41
#define SYS_SYSPWRSTATUS0_REG  42
#define SYS_SYSPWRSTATUS1_REG  43
#define SYS_SYSPWRSTATUS2_REG  44
#define SYS_SYSPWRSTATUS3_REG  45
#define SYS_SYSPWRSTATUS4_REG  46
#define SYS_SYSPWRSTATUS5_REG  47
#define SYS_SYSPWRSTATUS6_REG  48
#define SYS_SYSPWRSTATUS7_REG  49
#define SYS_SYSSTATUS_REG  50
#define SYS_SYSINTPOL_REG  51
#define SYS_SYSINTTYPE_REG  52
#define SYS_SYSINTSTATUS_REG  53
#define SYS_SYSINTENABLE0_REG  54
#define SYS_SYSINTENABLE1_REG  55
#define SYS_SYSUCOSECC_REG  56
#define SYS_SYSUCOMECC_REG  57
#define SYS_SYSUCOADDR_REG  58
#define SYS_SYSUCOINST_REG  59
#define SYS_SYSMEMBISTGO0_REG  60
#define SYS_SYSMEMBISTGO1_REG  61
#define SYS_SYSMEMBISTGO2_REG  62
#define SYS_SYSMEMBISTGO3_REG  63
#define SYS_SYSMEMBISTGO4_REG  64
#define SYS_SYSMEMBISTGO5_REG  65
#define SYS_SYSMEMBISTGO6_REG  66
#define SYS_SYSMEMBISTGO7_REG  67
#define SYS_SYSMEMBISTGO8_REG  68
#define SYS_SYSSCRATCH0_REG  69
#define SYS_SYSSCRATCH1_REG  70
#define SYS_SYSSCRATCH2_REG  71
#define SYS_SYSSCRATCH3_REG  72

#define SYS_PWRON_DIVF(x) ( (x >> 10) & 0x7f)
#define SYS_PWRON_DIVR(x) ( (x >> 8) & 0x3)
#define SYS_CORE_DFS(x,y) ( (x >> (y*4) ) & 0xf)

#define SYS_DMC_DISABLE_MASK 0x40
#define SYS_DMC_PLL_RESET(x) (x << 16)
#define SYS_DMC_PLL_DIVR(x) (x << 17)
#define SYS_DMC_PLL_DIVF(x) (x << 19)
#define SYS_DMC_DIV(x) ( (x >> 24) & 0xf)
#define SYS_DMC_PLL_RMW_MASK 0xffff

#define RD_DMC_PLL_DIVR(x) ( (x >> 17) & 0x3)
#define RD_DMC_PLL_DIVF(x) ( (x >> 19) & 0x7f)

#define SYS_DMC_DIV_DEC_MASK 0x40
#define SYS_DMC_DIV_INC_MASK 0x40

#ifndef __ASSEMBLY__
enum processor_sys
{
	SYS_CHIPRESET = 0,
	SYS_POWERONRESETCFG = 1,
	SYS_EFUSEDEVICECFG0 = 2,
	SYS_EFUSEDEVICECFG1 = 3,
	SYS_EFUSEDEVICECFG2 = 4,
	SYS_EFUSEDEVICECFG3 = 5,
	SYS_EFUSEDEVICECFG4 = 6,
	SYS_EFUSEDEVICECFG5 = 7,
	SYS_EFUSEDEVICECFG6 = 8,
	SYS_EFUSEDEVICECFG7 = 9,
	SYS_PLLCTRL = 10,
	SYS_CPURESET = 11,
	SYS_CPUTHREADEN = 12,
	SYS_CPUNONCOHERENTMODE = 13,
	SYS_COREDFSDISCTRL = 14,
	SYS_COREDFSRSTCTRL = 15,
	SYS_COREDFSBYPCTRL = 16,
	SYS_COREDFSPHACTRL = 17,
	SYS_COREDFSDIVINCCTRL = 18,
	SYS_COREDFSDIVDECCTRL = 19,
	SYS_COREDFSDIVCTRL = 20,
	SYS_SYSRESET = 21,
	SYS_SYSDFSDISCTRL = 22,
	SYS_SYSDFSRSTCTRL = 23,
	SYS_SYSDFSBYPCTRL = 24,
	SYS_SYSDFSDIVINCCTRL = 25,
	SYS_SYSDFSDIVDECCTRL = 26,
	SYS_SYSDFSDIVCTRL0 = 27,
	SYS_SYSDFSDIVCTRL1 = 28,
	SYS_CPUSENSEAMPDLY = 29,
	SYS_SOCSENSEAMPDLY = 30,
	SYS_SYSCTRL0 = 31,
	SYS_SYSCTRL1 = 32,
	SYS_TIMEOUTBSI = 33,
	SYS_BYTESWAP = 34,
	SYS_SYSVRMVID = 35,
	SYS_SYSPWRRAMCMD = 36,
	SYS_SYSPWRRAMADDR = 37,
	SYS_SYSPWRRAMDATA0 = 38,
	SYS_SYSPWRRAMDATA1 = 39,
	SYS_SYSPWRRAMDATA2 = 40,
	SYS_SYSPWRUCODE = 41,
	SYS_SYSPWRSTATUS0 = 42,
	SYS_SYSPWRSTATUS1 = 43,
	SYS_SYSPWRSTATUS2 = 44,
	SYS_SYSPWRSTATUS3 = 45,
	SYS_SYSPWRSTATUS4 = 46,
	SYS_SYSPWRSTATUS5 = 47,
	SYS_SYSPWRSTATUS6 = 48,
	SYS_SYSPWRSTATUS7 = 49,
	SYS_SYSSTATUS = 50,
	SYS_SYSINTPOL = 51,
	SYS_SYSINTTYPE = 52,
	SYS_SYSINTSTATUS = 53,
	SYS_SYSINTENABLE0 = 54,
	SYS_SYSINTENABLE1 = 55,
	SYS_SYSUCOSECC = 56,
	SYS_SYSUCOMECC = 57,
	SYS_SYSUCOADDR = 58,
	SYS_SYSUCOINST = 59,
	SYS_SYSMEMBISTGO0 = 60,
	SYS_SYSMEMBISTGO1 = 61,
	SYS_SYSMEMBISTGO2 = 62,
	SYS_SYSMEMBISTGO3 = 63,
	SYS_SYSMEMBISTGO4 = 64,
	SYS_SYSMEMBISTGO5 = 65,
	SYS_SYSMEMBISTGO6 = 66,
	SYS_SYSMEMBISTGO7 = 67,
	SYS_SYSMEMBISTGO8 = 68,
	SYS_SYSMEMBISTGO9 = 69,
	SYS_SYSMEMBISTGO10 = 70,
	SYS_SYSMEMBISTGO11 = 71,
	SYS_SYSMEMBISTGO12 = 72,
	SYS_SYSSCRATCH0 = 73,
	SYS_SYSSCRATCH1 = 74,
	SYS_SYSSCRATCH2 = 75,
	SYS_SYSSCRATCH3 = 76
};
#endif

#endif /* __XLP_SYS_H__ */
